from pyglet import window
from pyglet import clock
from pyglet import font
from pyglet import event
import engine
import flight_engine
import texman
import conf

import data
import conf
import euclid
from pyglet.gl import *
fps_display = clock.ClockDisplay()

class UserInput(object):
    def __init__(self):
        self.dx = 0
        self.dy = 0
        


class LawnWindow(window.Window):
    def __init__(*args, **kwargs):
        self = args[0]
        window.Window.__init__(*args,**kwargs)
        texman.init_textures()
        #clock.set_fps_limit(conf.framerate)
        self.frame = 0
        clock.schedule_interval(self.update, 1.0/conf.framerate)
        self.keys = window.key.KeyStateHandler()
        self.push_handlers(self.keys)
        self.engine = flight_engine.FlightEngine()
        
        self.next_engine = None
        self.user_input = UserInput()
        self.set_exclusive_mouse(True)
    def update(self, dt):
        self.frame += 1
        if self.engine:
            update_result = self.engine.update(self, self.user_input, dt)
            if update_result == engine.END_ENGINE:
                if self.next_engine:
                    if self.engine == self.next_engine:
                        self.engine.initGLview(self.width, self.height)
                    else:
                        pyglet.app.exit()

    def on_key_press(self,sym, modifiers):
        self.check_window_controls(sym, modifiers)
        window.Window.on_key_press(self, sym, modifiers)
        return pyglet.event.EVENT_HANDLED
    
    def on_mouse_motion(self, x, y, dx, dy):
        self.user_input.dx = dx
        self.user_input.dy = dy
        
    def check_window_controls(self,sym, modifiers):
        if sym == window.key.ENTER and modifiers & window.key.MOD_ALT:
            self.toggle_fullscreen()

    def toggle_fullscreen(self):
        self.set_fullscreen(not self.fullscreen)
        
    def on_resize(self, width, height):
        print "resize ", width, height
        if self.engine:
            self.engine.initGLview(width, height)
        window.Window.on_resize(self, width, height)
        return pyglet.event.EVENT_HANDLED

    def on_draw(self):
        self.clear()
        glMatrixMode(GL_PROJECTION)
        glPushMatrix()
        glEnable(GL_DEPTH_TEST)
        glMatrixMode(GL_MODELVIEW)
        glPushMatrix()
        if self.engine:
            self.engine.render(self)
        glMatrixMode(GL_MODELVIEW)
        glPopMatrix()
        glMatrixMode(GL_PROJECTION)
        glPopMatrix()
        glDisable(GL_DEPTH_TEST)
        glDisable(GL_TEXTURE_2D)
        fps_display.draw()
